
import numpy as np
import matplotlib.pyplot as plt

x = np.random.random(20)
y = 4.5 * x + 2.0

# add random noise from a normal (Gaussian) distribution.
mu = 0.0
sigma = 0.5    # change noise!
noise = np.random.normal(mu, sigma, y.size)
yn = y + noise
plt.plot(x, y, 'r+')
plt.plot(x, yn, 'bx')
plt.show()

from sklearn.linear_model import LinearRegression
reg = LinearRegression()
#reg.fit(x, yn)    # does not work! x is {ndarray: (20,), we need a matrix}

# numpy reshape
t = x.reshape(4, 5)    # 4 rows and 5 columns = 20 elements
x = x.reshape(-1, 1)  # {ndarray: (20, 1)} 20 examples with one feature
                       # One shape dimension can be -1. In this case,
                       # the value is inferred from the length of the array
                       # and remaining dimensions.
reg.fit(x, yn)

print(f'We used y = 4.5 * x + 2.0\n' +
      f'LinearRegression got y = {reg.coef_} * x + {reg.intercept_}')

# show prediction with line plot
yp = reg.predict(x)
plt.plot(x, y, 'r-')
plt.plot(x, yn, 'bx')
plt.plot(x, yp, 'g-')
plt.show()

# Mean squared error or MSE
print(np.mean((yp-y)**2))
# or sklearn.metrics.mean_squared_error
from sklearn import metrics
print(metrics.mean_squared_error(y, yp))
