# x^2 example with LinearRegression

import numpy as np
import matplotlib.pyplot as plt
from sklearn.linear_model import LinearRegression
from sklearn import metrics

np.random.seed(1)

x = np.random.random(20)
x = x.reshape(-1, 1)  # {ndarray: (20, 1)}
y = 4.5 * x + 2.0

x2 = 4 * (x-0.5)
y2 = 4.5 * x2**2 - 3.0
plt.plot(x2, y2, 'r+')
plt.show()

reg = LinearRegression()
reg.fit(x2, y2)

y2p = reg.predict(x2)
plt.plot(x2, y2, 'r+')
plt.plot(x2, y2p, 'g-')
plt.show()
print(f'MSE: {metrics.mean_squared_error(y2, y2p)}')
